using System;

namespace UMD.HCIL.Piccolo {
	/// <summary>
	/// Piccolo.NET is a general-purpose c#-based engine that supports 2D visualizations. 
	/// A primary characteristic of Piccolo.NET is that it is designed to support zoomable 
	/// information spaces, although any particular applications may or may not
	/// take advantage of this feature. Piccolo is implemented entirely in C#, 
	/// and as such runs identically on any platform that supports the CLR.
	/// <para>
	/// Piccolo is not an application in itself, but rather it is an engine that is designed 
	/// to support applications that require the ability to create, manipulate, and render 
	/// object-oriented graphics. If you are familiar with the terminology of 3D graphics, 
	/// Piccolo supports a scenegraph. This is a data structure that represents a hierarchy 
	/// of graphical objects. Piccolo uses a tuned run-time system to render the scenegraph 
	/// as quickly as possible to support interactive applications.
	/// </para>
	/// <para>
	/// This is the root namespace for all Piccolo classes. It contains the core scenegraph
	/// classes itself, and in addition, contains the <see cref="Activities">Activities</see>,
	/// <see cref="Event">Event</see>, <see cref="Nodes">Nodes</see> and
	/// <see cref="Util">Util</see> namespaces that are used to build Piccolo applications.
	/// </para>
	/// </summary>
	public class NamespaceDoc {
	}
}